Imports System
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports PDFTRON
Imports PDFTRON.PDF


#If CUSTOM_NAV Then
' <summary>
' ThumbView is provided as an illustration of how to derive a new class 
' from pdftron.PDF.PDFViewCtrl. You can fully customize this class to meet 
' your specific application requrements.
' 
' Note: 
' A mouse click on the page thumbnail changes the current page number 
' in the main PDF view. 
' </summary>
Public Class ThumbView
    Inherits PDFViewCtrl

    Public Sub New()
        MyBase.New()
        ' For faster, but lower quality rendering uncomment the following line:
        SetImageSmoothing(False)
    End Sub
    Private _main_view As PDFViewCtrl = Nothing

    Public Overloads Sub SetDoc(ByVal doc As PDFDoc, ByVal main_view As PDFViewCtrl)
        MyBase.SetDoc(doc)
        _main_view = main_view
    End Sub

    Protected Overloads Overrides Sub OnPaint(ByVal e As PaintEventArgs)
        MyBase.OnPaint(e) ' Draw PDF thumbnails as a background.
        If Not (_main_view Is Nothing) Then
            Dim cur_page As Integer = _main_view.GetCurrentPage
            If cur_page < 1 Then
                Return
            End If
            Dim page As PDFTRON.PDF.Page = GetDoc.GetPage(cur_page)

            'Draw a red border around the selected page.
            Dim bbox As PDFTRON.PDF.Rect = page.GetCropBox
            bbox.Normalize()
            Dim left As Double = bbox.x1
            Dim bottom As Double = bbox.y1
            Dim right As Double = bbox.x2
            Dim top As Double = bbox.y2
            Dim tmp As Double
            ConvPagePtToScreenPt(left, bottom, cur_page)
            ConvPagePtToScreenPt(right, top, cur_page)
            If top < bottom Then
                tmp = top
                top = bottom
                bottom = tmp
            End If
            If right < left Then
                tmp = right
                right = left
                left = tmp
            End If
            e.Graphics.DrawRectangle(Pens.Red, CType((left - 2), Single), CType((bottom - 2), Single), CType((right - left + 4), Single), CType((top - bottom + 4), Single))
        End If
    End Sub

    Protected Overloads Overrides Sub OnMouseDown(ByVal e As MouseEventArgs)
        If Not (_main_view Is Nothing) Then
            Dim cur_page As Integer = GetPageNumberFromScreenPt(e.X, e.Y)
            If cur_page < 1 Then
                Return
            Else
                _main_view.SetCurrentPage(cur_page)
            End If
            Invalidate()
        End If
    End Sub

    Protected Overloads Overrides Sub OnPaintBackground(ByVal pevent As PaintEventArgs)
    End Sub
End Class
#End If